#include <GestaltEqu.h>
#include "Useful.h"
#include "Essential.h"

//	The Essence-Shell Hack Patch Installer

typedef struct {
	long	GestaltSelector;
	short	gestaltoffset;
	struct Trap_to_Patch {
		short	trap_or_vector;
		short	offset;
	} traps[];
} hack;

void *AddressFromOffset(short *offset);

main(void) {
	struct Trap_to_Patch *T2P;
	hack	**Patches;
	hack	*p;
	long	GestaltResponse;
	void	**trap;

	short	icon = 129;	// fail by default.

	SetA4(&main);	// set up global access.  Ideally we would restore a4 on the way
					// out, but the INIT loader does this for us and has done so
					// since the beginning of INIT 31.

		// first, don't load if the shift key is down.
	if (keymap.shift) goto ShowINIT;

		// second, load the real patches.
	Patches = (void *)GetResource('init', 0);
		// if we can't, ditch.
	if (!Patches) goto ShowINIT;

	p = *Patches;
		// third, test to see if we're already installed, and ditch if we are.
	if (Gestalt(p->GestaltSelector, &GestaltResponse) == noErr) goto ShowINIT;

		// ok, we're all set.  First, install the gestalt selector, and ditch if
		// we can't install it.
	if (NewGestalt(p->GestaltSelector, AddressFromOffset(&p->gestaltoffset)) != noErr) goto ShowINIT;
		// ok, we installed the gestalt routine.  no pulling out now!
		// so since we can't pull out, this is the time to detach our patch code.
		// note that if we don't do this, the resource gets released as our file
		// gets closed.
	DetachResource(Patches);

	// ok, now install all the patches.
	for (T2P = p->traps; ; T2P++) {
		ushort trap_or_vector = T2P->trap_or_vector;
		if (trap_or_vector == 0) break;
		trap = AddressFromOffset(&T2P->offset);
		if (trap_or_vector < 0x1000) {
			// we are patching a low-memory vector.
			*trap++ = *(void **)trap_or_vector;
			*(void **)trap_or_vector = trap;
		} else {
			trap_or_vector -= 0xA000;
			if (trap_or_vector < 0x800) {
				trap_or_vector &= 0xFF;
				*trap++ = (void *)GetOSTrapAddress(trap_or_vector);
				SetOSTrapAddress((long)trap, trap_or_vector);
			} else {
				trap_or_vector -= 0x800;
				if (trap_or_vector < 0x800) {
					*trap++ = (void *)GetToolTrapAddress(trap_or_vector);
					SetToolTrapAddress((long)trap, trap_or_vector);
				} else DebugStr("\pUnknown trap!");
			}
		}
	}
	icon = 128;	// whew! everything seems to have worked.
	goto ShowINIT;

ShowINIT:
	ShowINIT(icon);
}

void *AddressFromOffset(short *offset) {
	return *offset + (uchar *)offset;
}